diff --git a/gcc/c/c-decl.c b/gcc/c/c-decl.c
index 2c41bf2..cf61dfe 100644
--- a/gcc/c/c-decl.c
+++ b/gcc/c/c-decl.c
@@ -598,7 +598,7 @@ decl_jump_unsafe (tree decl)
 
   /* Otherwise, only warn if -Wgoto-misses-init and this is an
      initialized automatic decl.  */
-  if (warn_jump_misses_init
+  if (GCC_OPTION (warn_jump_misses_init)
       && TREE_CODE (decl) == VAR_DECL
       && !TREE_STATIC (decl)
       && DECL_INITIAL (decl) != NULL_TREE)
@@ -1174,7 +1174,7 @@ pop_scope (void)
 	      /* C99 6.7.4p6: "a function with external linkage... declared
 		 with an inline function specifier ... shall also be defined
 		 in the same translation unit."  */
-	      if (!flag_gnu89_inline)
+	      if (!GCC_OPTION (flag_gnu89_inline))
 		pedwarn (input_location, 0,
 			 "inline function %q+D declared but never defined", p);
 	      DECL_EXTERNAL (p) = 1;
@@ -1464,7 +1464,7 @@ pushtag (location_t loc, tree name, tree type)
      This will be updated in pop_scope.  */
   TYPE_CONTEXT (type) = DECL_CONTEXT (TYPE_STUB_DECL (type));
 
-  if (warn_cxx_compat && name != NULL_TREE)
+  if (GCC_OPTION (warn_cxx_compat) && name != NULL_TREE)
     {
       struct c_binding *b = I_SYMBOL_BINDING (name);
 
@@ -1843,7 +1843,7 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 		 newdecl);
 	  locate_old_decl (olddecl);
 	}
-      else if (pedantic && !flag_isoc11)
+      else if (GCC_OPTION (pedantic) && !flag_isoc11)
 	{
 	  pedwarn (input_location, OPT_Wpedantic,
 		   "redefinition of typedef %q+D", newdecl);
@@ -1889,7 +1889,7 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 		 unit.  */
 	      if ((!DECL_EXTERN_INLINE (olddecl)
 		   || DECL_EXTERN_INLINE (newdecl)
-		   || (!flag_gnu89_inline
+		   || (!GCC_OPTION (flag_gnu89_inline)
 		       && (!DECL_DECLARED_INLINE_P (olddecl)
 			   || !lookup_attribute ("gnu_inline",
 						 DECL_ATTRIBUTES (olddecl)))
@@ -1949,7 +1949,7 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 	      locate_old_decl (olddecl);
 	      return false;
 	    }
-	  else if (warn_traditional)
+	  else if (GCC_OPTION (warn_traditional))
 	    {
 	      warned |= warning (OPT_Wtraditional,
 				 "non-static declaration of %q+D "
@@ -2027,7 +2027,7 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 		  locate_old_decl (olddecl);
 		  return false;
 		}
-	      else if (warn_traditional)
+	      else if (GCC_OPTION (warn_traditional))
 		{
 		  warned |= warning (OPT_Wtraditional,
 				     "non-static declaration of %q+D "
@@ -2073,7 +2073,7 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 
       /* C++ does not permit a decl to appear multiple times at file
 	 scope.  */
-      if (warn_cxx_compat
+      if (GCC_OPTION (warn_cxx_compat)
 	  && DECL_FILE_SCOPE_P (newdecl)
 	  && !DECL_EXTERNAL (newdecl)
 	  && !DECL_EXTERNAL (olddecl))
@@ -2134,7 +2134,7 @@ diagnose_mismatched_decls (tree newdecl, tree olddecl,
 
   /* Optional warning for completely redundant decls.  */
   if (!warned && !pedwarned
-      && warn_redundant_decls
+      && GCC_OPTION (warn_redundant_decls)
       /* Don't warn about a function declaration followed by a
 	 definition.  */
       && !(TREE_CODE (newdecl) == FUNCTION_DECL
@@ -2332,7 +2332,7 @@ merge_decls (tree newdecl, tree olddecl, tree newtype, tree oldtype)
      function is not DECL_EXTERNAL, unless 'gnu_inline' attribute
      is present.  */
   if (TREE_CODE (newdecl) == FUNCTION_DECL
-      && !flag_gnu89_inline
+      && !GCC_OPTION (flag_gnu89_inline)
       && (DECL_DECLARED_INLINE_P (newdecl)
 	  || DECL_DECLARED_INLINE_P (olddecl))
       && (!DECL_DECLARED_INLINE_P (newdecl)
@@ -2552,7 +2552,7 @@ warn_if_shadowing (tree new_decl)
   struct c_binding *b;
 
   /* Shadow warnings wanted?  */
-  if (!warn_shadow
+  if (!GCC_OPTION (warn_shadow)
       /* No shadow warnings for internally generated vars.  */
       || DECL_IS_BUILTIN (new_decl)
       /* No shadow warnings for vars made for inlining.  */
@@ -2899,7 +2899,7 @@ pushdecl_top_level (tree x)
 static void
 implicit_decl_warning (tree id, tree olddecl)
 {
-  if (warn_implicit_function_declaration)
+  if (GCC_OPTION (warn_implicit_function_declaration))
     {
       bool warned;
 
@@ -4165,7 +4165,7 @@ start_decl (struct c_declarator *declarator, struct c_declspecs *declspecs,
       && !initialized
       && TREE_PUBLIC (decl)
       && !DECL_THREAD_LOCAL_P (decl)
-      && !flag_no_common)
+      && !GCC_OPTION (flag_no_common))
     DECL_COMMON (decl) = 1;
 
   /* Set attributes here so if duplicate decl, will have proper attributes.  */
@@ -4173,7 +4173,7 @@ start_decl (struct c_declarator *declarator, struct c_declspecs *declspecs,
 
   /* Handle gnu_inline attribute.  */
   if (declspecs->inline_p
-      && !flag_gnu89_inline
+      && !GCC_OPTION (flag_gnu89_inline)
       && TREE_CODE (decl) == FUNCTION_DECL
       && (lookup_attribute ("gnu_inline", DECL_ATTRIBUTES (decl))
 	  || current_function_decl))
@@ -4327,7 +4327,7 @@ finish_decl (tree decl, location_t init_loc, tree init,
 	= (TREE_STATIC (decl)
 	   /* Even if pedantic, an external linkage array
 	      may have incomplete type at first.  */
-	   ? pedantic && !TREE_PUBLIC (decl)
+	   ? GCC_OPTION (pedantic) && !TREE_PUBLIC (decl)
 	   : !DECL_EXTERNAL (decl));
       int failure
 	= complete_array_type (&TREE_TYPE (decl), DECL_INITIAL (decl),
@@ -4351,7 +4351,7 @@ finish_decl (tree decl, location_t init_loc, tree init,
 	     If it is not `static', then do not mark extern;
 	     finish_incomplete_decl will give it a default size
 	     and it will get allocated.  */
-	  else if (!pedantic && TREE_STATIC (decl) && !TREE_PUBLIC (decl))
+	  else if (!GCC_OPTION (pedantic) && TREE_STATIC (decl) && !TREE_PUBLIC (decl))
 	    DECL_EXTERNAL (decl) = 1;
 	  break;
 
@@ -4581,7 +4581,7 @@ finish_decl (tree decl, location_t init_loc, tree init,
 	}
     }
 
-  if (warn_cxx_compat
+  if (GCC_OPTION (warn_cxx_compat)
       && TREE_CODE (decl) == VAR_DECL
       && !DECL_EXTERNAL (decl)
       && DECL_INITIAL (decl) == NULL_TREE)
@@ -4644,7 +4644,7 @@ mark_forward_parm_decls (void)
 {
   struct c_binding *b;
 
-  if (pedantic && !current_scope->warned_forward_parm_decls)
+  if (GCC_OPTION (pedantic) && !current_scope->warned_forward_parm_decls)
     {
       pedwarn (input_location, OPT_Wpedantic,
 	       "ISO C forbids forward parameter declarations");
@@ -4740,7 +4740,7 @@ build_compound_literal (location_t loc, tree type, tree init, bool non_const)
 void
 check_compound_literal_type (location_t loc, struct c_type_name *type_name)
 {
-  if (warn_cxx_compat
+  if (GCC_OPTION (warn_cxx_compat)
       && (type_name->specs->typespec_kind == ctsk_tagdef
           || type_name->specs->typespec_kind == ctsk_tagfirstref))
     warning_at (loc, OPT_Wc___compat,
@@ -4875,7 +4875,7 @@ warn_variable_length_array (tree name, tree size)
 {
   int const_size = TREE_CONSTANT (size);
 
-  if (!flag_isoc99 && pedantic && warn_vla != 0)
+  if (!flag_isoc99 && GCC_OPTION (pedantic) && GCC_OPTION (warn_vla) != 0)
     {
       if (const_size)
 	{
@@ -4898,7 +4898,7 @@ warn_variable_length_array (tree name, tree size)
 	    pedwarn (input_location, OPT_Wvla, "ISO C90 forbids variable length array");
 	}
     }
-  else if (warn_vla > 0)
+  else if (GCC_OPTION (warn_vla) > 0)
     {
       if (const_size)
         {
@@ -5093,7 +5093,7 @@ grokdeclarator (const struct c_declarator *declarator,
       /* Issue a warning if this is an ISO C 99 program or if
 	 -Wreturn-type and this is a function, or if -Wimplicit;
 	 prefer the former warning since it is more explicit.  */
-      if ((warn_implicit_int || warn_return_type || flag_isoc99)
+      if ((GCC_OPTION (warn_implicit_int) || GCC_OPTION (warn_return_type) || flag_isoc99)
 	  && funcdef_flag)
 	warn_about_return_type = 1;
       else
@@ -5111,7 +5111,7 @@ grokdeclarator (const struct c_declarator *declarator,
   /* Adjust the type if a bit-field is being declared,
      -funsigned-bitfields applied and the type is not explicitly
      "signed".  */
-  if (bitfield && !flag_signed_bitfields && !declspecs->explicit_signed_p
+  if (bitfield && !GCC_OPTION (flag_signed_bitfields) && !declspecs->explicit_signed_p
       && TREE_CODE (type) == INTEGER_TYPE)
     type = unsigned_type_for (type);
 
@@ -5135,7 +5135,7 @@ grokdeclarator (const struct c_declarator *declarator,
   as2 = TYPE_ADDR_SPACE (element_type);
   address_space = ADDR_SPACE_GENERIC_P (as1)? as2 : as1;
 
-  if (pedantic && !flag_isoc99)
+  if (GCC_OPTION (pedantic) && !flag_isoc99)
     {
       if (constp > 1)
 	pedwarn (loc, OPT_Wpedantic, "duplicate %<const%>");
@@ -5234,7 +5234,7 @@ grokdeclarator (const struct c_declarator *declarator,
          {
            /* It is fine to have 'extern const' when compiling at C
               and C++ intersection.  */
-           if (!(warn_cxx_compat && constp))
+           if (!(GCC_OPTION (warn_cxx_compat) && constp))
              warning_at (loc, 0, "%qE initialized and declared %<extern%>",
 		 	 name);
          }
@@ -5246,7 +5246,7 @@ grokdeclarator (const struct c_declarator *declarator,
       if (storage_class == csc_auto)
 	error_at (loc, "file-scope declaration of %qE specifies %<auto%>",
 	    	  name);
-      if (pedantic && storage_class == csc_register)
+      if (GCC_OPTION (pedantic) && storage_class == csc_register)
 	pedwarn (input_location, OPT_Wpedantic,
 		 "file-scope declaration of %qE specifies %<register%>", name);
     }
@@ -5368,7 +5368,7 @@ grokdeclarator (const struct c_declarator *declarator,
 		type = error_mark_node;
 	      }
 
-	    if (pedantic && !in_system_header_at (input_location)
+	    if (GCC_OPTION (pedantic) && !in_system_header_at (input_location)
 		&& flexible_array_type_p (type))
 	      pedwarn (loc, OPT_Wpedantic,
 		       "invalid use of structure with flexible array member");
@@ -5407,7 +5407,7 @@ grokdeclarator (const struct c_declarator *declarator,
 
 		size = c_fully_fold (size, false, &size_maybe_const);
 
-		if (pedantic && size_maybe_const && integer_zerop (size))
+		if (GCC_OPTION (pedantic) && size_maybe_const && integer_zerop (size))
 		  {
 		    if (name)
 		      pedwarn (loc, OPT_Wpedantic,
@@ -5460,7 +5460,7 @@ grokdeclarator (const struct c_declarator *declarator,
 		       with known value.  */
 		    this_size_varies = size_varies = true;
 		    warn_variable_length_array (name, size);
-		    if (flag_sanitize & SANITIZE_VLA
+		    if (GCC_OPTION (flag_sanitize) & SANITIZE_VLA
 		        && decl_context == NORMAL)
 		      {
 			/* Evaluate the array size only once.  */
@@ -5547,7 +5547,7 @@ grokdeclarator (const struct c_declarator *declarator,
 		    flexible_array_member = (t->kind == cdk_id);
 		  }
 		if (flexible_array_member
-		    && pedantic && !flag_isoc99
+		    && GCC_OPTION (pedantic) && !flag_isoc99
 		    && !in_system_header_at (input_location))
 		  pedwarn (loc, OPT_Wpedantic,
 			   "ISO C90 does not support flexible array members");
@@ -5754,7 +5754,7 @@ grokdeclarator (const struct c_declarator *declarator,
 			  "%<_Atomic%>-qualified function type");
 		type_quals &= ~TYPE_QUAL_ATOMIC;
 	      }
-	    else if (pedantic && TREE_CODE (type) == FUNCTION_TYPE
+	    else if (GCC_OPTION (pedantic) && TREE_CODE (type) == FUNCTION_TYPE
 		     && type_quals)
 	      pedwarn (loc, OPT_Wpedantic,
 		       "ISO C forbids qualified function types");
@@ -5952,7 +5952,7 @@ grokdeclarator (const struct c_declarator *declarator,
 		    "%<_Atomic%>-qualified function type");
 	  type_quals &= ~TYPE_QUAL_ATOMIC;
 	}
-      else if (pedantic && TREE_CODE (type) == FUNCTION_TYPE
+      else if (GCC_OPTION (pedantic) && TREE_CODE (type) == FUNCTION_TYPE
 	       && type_quals)
 	pedwarn (loc, OPT_Wpedantic,
 		 "ISO C forbids qualified function types");
@@ -5967,7 +5967,7 @@ grokdeclarator (const struct c_declarator *declarator,
       if (declspecs->noreturn_p)
 	pedwarn (loc, 0,"typedef %q+D declared %<_Noreturn%>", decl);
 
-      if (warn_cxx_compat && declarator->u.id != NULL_TREE)
+      if (GCC_OPTION (warn_cxx_compat) && declarator->u.id != NULL_TREE)
 	{
 	  struct c_binding *b = I_TAG_BINDING (declarator->u.id);
 
@@ -6005,7 +6005,7 @@ grokdeclarator (const struct c_declarator *declarator,
 		    "%<_Atomic%>-qualified function type");
 	  type_quals &= ~TYPE_QUAL_ATOMIC;
 	}
-      else if (pedantic && TREE_CODE (type) == FUNCTION_TYPE
+      else if (GCC_OPTION (pedantic) && TREE_CODE (type) == FUNCTION_TYPE
 	       && type_quals)
 	pedwarn (loc, OPT_Wpedantic,
 		 "ISO C forbids const or volatile function types");
@@ -6014,7 +6014,7 @@ grokdeclarator (const struct c_declarator *declarator,
       return type;
     }
 
-  if (pedantic && decl_context == FIELD
+  if (GCC_OPTION (pedantic) && decl_context == FIELD
       && variably_modified_type_p (type, NULL_TREE))
     {
       /* C99 6.7.2.1p8 */
@@ -6179,7 +6179,7 @@ grokdeclarator (const struct c_declarator *declarator,
 		      "%<_Atomic%>-qualified function type");
 	    type_quals &= ~TYPE_QUAL_ATOMIC;
 	  }
-	else if (pedantic && type_quals && !DECL_IN_SYSTEM_HEADER (decl))
+	else if (GCC_OPTION (pedantic) && type_quals && !DECL_IN_SYSTEM_HEADER (decl))
 	  pedwarn (loc, OPT_Wpedantic,
 		   "ISO C forbids qualified function types");
 
@@ -6197,7 +6197,7 @@ grokdeclarator (const struct c_declarator *declarator,
 	   'extern inline' is an external reference.  */
 	else if (declspecs->inline_p && storage_class != csc_static)
 	  DECL_EXTERNAL (decl) = ((storage_class == csc_extern)
-				  == flag_gnu89_inline);
+				  == GCC_OPTION (flag_gnu89_inline));
 	else
 	  DECL_EXTERNAL (decl) = !initialized;
 
@@ -6359,7 +6359,7 @@ grokdeclarator (const struct c_declarator *declarator,
      name of a variable.  Thus, if it's known before this, die horribly.  */
     gcc_assert (!DECL_ASSEMBLER_NAME_SET_P (decl));
 
-    if (warn_cxx_compat
+    if (GCC_OPTION (warn_cxx_compat)
 	&& TREE_CODE (decl) == VAR_DECL
 	&& TREE_PUBLIC (decl)
 	&& TREE_STATIC (decl)
@@ -6734,7 +6734,7 @@ parser_xref_tag (location_t loc, enum tree_code code, tree name)
     {
       if (C_TYPE_DEFINED_IN_STRUCT (ref)
 	  && loc != UNKNOWN_LOCATION
-	  && warn_cxx_compat)
+	  && GCC_OPTION (warn_cxx_compat))
 	{
 	  switch (code)
 	    {
@@ -6858,7 +6858,7 @@ start_struct (location_t loc, enum tree_code code, tree name,
     }
 
   C_TYPE_BEING_DEFINED (ref) = 1;
-  TYPE_PACKED (ref) = flag_pack_struct;
+  TYPE_PACKED (ref) = GCC_OPTION (flag_pack_struct);
 
   *enclosing_struct_parse_info = struct_parse_info;
   struct_parse_info = XNEW (struct c_struct_parse_info);
@@ -6870,7 +6870,7 @@ start_struct (location_t loc, enum tree_code code, tree name,
      within a statement expr used within sizeof, et. al.  This is not
      terribly serious as C++ doesn't permit statement exprs within
      sizeof anyhow.  */
-  if (warn_cxx_compat && (in_sizeof || in_typeof || in_alignof))
+  if (GCC_OPTION (warn_cxx_compat) && (in_sizeof || in_typeof || in_alignof))
     warning_at (loc, OPT_Wc___compat,
 		"defining type in %qs expression is invalid in C++",
 		(in_sizeof
@@ -6928,11 +6928,11 @@ grokfield (location_t loc,
       bool ok = false;
 
       if (type_ok
-	  && (flag_ms_extensions
-	      || flag_plan9_extensions
+	  && (GCC_OPTION (flag_ms_extensions)
+	      || GCC_OPTION (flag_plan9_extensions)
 	      || !declspecs->typedef_p))
 	{
-	  if (flag_ms_extensions || flag_plan9_extensions)
+	  if (GCC_OPTION (flag_ms_extensions) || GCC_OPTION (flag_plan9_extensions))
 	    ok = true;
 	  else if (TYPE_NAME (type) == NULL)
 	    ok = true;
@@ -6962,7 +6962,7 @@ grokfield (location_t loc,
   finish_decl (value, loc, NULL_TREE, NULL_TREE, NULL_TREE);
   DECL_INITIAL (value) = width;
 
-  if (warn_cxx_compat && DECL_NAME (value) != NULL_TREE)
+  if (GCC_OPTION (warn_cxx_compat) && DECL_NAME (value) != NULL_TREE)
     {
       /* If we currently have a binding for this field, set the
 	 in_struct field in the binding, so that we warn about lookups
@@ -6995,7 +6995,7 @@ is_duplicate_field (tree x, tree y)
 
   /* When using -fplan9-extensions, an anonymous field whose name is a
      typedef can duplicate a field name.  */
-  if (flag_plan9_extensions
+  if (GCC_OPTION (flag_plan9_extensions)
       && (DECL_NAME (x) == NULL_TREE || DECL_NAME (y) == NULL_TREE))
     {
       tree xt, xn, yt, yn;
@@ -7055,7 +7055,7 @@ detect_field_duplicates_hash (tree fieldlist,
 
 	/* When using -fplan9-extensions, an anonymous field whose
 	   name is a typedef can duplicate a field name.  */
-	if (flag_plan9_extensions
+	if (GCC_OPTION (flag_plan9_extensions)
 	    && TYPE_NAME (TREE_TYPE (x)) != NULL_TREE
 	    && TREE_CODE (TYPE_NAME (TREE_TYPE (x))) == TYPE_DECL)
 	  {
@@ -7115,7 +7115,7 @@ detect_field_duplicates (tree fieldlist)
 	/* When using -fplan9-extensions, we can have duplicates
 	   between typedef names and fields.  */
 	if (DECL_NAME (x)
-	    || (flag_plan9_extensions
+	    || (GCC_OPTION (flag_plan9_extensions)
 		&& DECL_NAME (x) == NULL_TREE
 		&& (TREE_CODE (TREE_TYPE (x)) == RECORD_TYPE
 		    || TREE_CODE (TREE_TYPE (x)) == UNION_TYPE)
@@ -7219,7 +7219,7 @@ finish_struct (location_t loc, tree t, tree fieldlist, tree attributes,
 
   decl_attributes (&t, attributes, (int) ATTR_FLAG_TYPE_IN_PLACE);
 
-  if (pedantic)
+  if (GCC_OPTION (pedantic))
     {
       for (x = fieldlist; x; x = DECL_CHAIN (x))
 	{
@@ -7325,7 +7325,7 @@ finish_struct (location_t loc, tree t, tree fieldlist, tree attributes,
 	    }
 	}
 
-      if (pedantic && TREE_CODE (t) == RECORD_TYPE
+      if (GCC_OPTION (pedantic) && TREE_CODE (t) == RECORD_TYPE
 	  && flexible_array_type_p (TREE_TYPE (x)))
 	pedwarn (DECL_SOURCE_LOCATION (x), OPT_Wpedantic,
 		 "invalid use of structure with flexible array member");
@@ -7482,7 +7482,7 @@ finish_struct (location_t loc, tree t, tree fieldlist, tree attributes,
     add_stmt (build_stmt (loc,
 			  DECL_EXPR, build_decl (loc, TYPE_DECL, NULL, t)));
 
-  if (warn_cxx_compat)
+  if (GCC_OPTION (warn_cxx_compat))
     warn_cxx_compat_finish_struct (fieldlist);
 
   struct_parse_info->struct_types.release ();
@@ -7494,7 +7494,7 @@ finish_struct (location_t loc, tree t, tree fieldlist, tree attributes,
 
   /* If this struct is defined inside a struct, add it to
      struct_types.  */
-  if (warn_cxx_compat
+  if (GCC_OPTION (warn_cxx_compat)
       && struct_parse_info != NULL
       && !in_sizeof && !in_typeof && !in_alignof)
     struct_parse_info->struct_types.safe_push (t);
@@ -7558,13 +7558,13 @@ start_enum (location_t loc, struct c_enum_contents *the_enum, tree name)
   the_enum->enum_next_value = integer_zero_node;
   the_enum->enum_overflow = 0;
 
-  if (flag_short_enums)
+  if (GCC_OPTION (flag_short_enums))
     TYPE_PACKED (enumtype) = 1;
 
   /* FIXME: This will issue a warning for a use of a type defined
      within sizeof in a statement expr.  This is not terribly serious
      as C++ doesn't permit statement exprs within sizeof anyhow.  */
-  if (warn_cxx_compat && (in_sizeof || in_typeof || in_alignof))
+  if (GCC_OPTION (warn_cxx_compat) && (in_sizeof || in_typeof || in_alignof))
     warning_at (loc, OPT_Wc___compat,
 		"defining type in %qs expression is invalid in C++",
 		(in_sizeof
@@ -7712,7 +7712,7 @@ finish_enum (tree enumtype, tree values, tree attributes)
 
   /* If this enum is defined inside a struct, add it to
      struct_types.  */
-  if (warn_cxx_compat
+  if (GCC_OPTION (warn_cxx_compat)
       && struct_parse_info != NULL
       && !in_sizeof && !in_typeof && !in_alignof)
     struct_parse_info->struct_types.safe_push (enumtype);
@@ -7876,7 +7876,7 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
 
   /* Handle gnu_inline attribute.  */
   if (declspecs->inline_p
-      && !flag_gnu89_inline
+      && !GCC_OPTION (flag_gnu89_inline)
       && TREE_CODE (decl1) == FUNCTION_DECL
       && (lookup_attribute ("gnu_inline", DECL_ATTRIBUTES (decl1))
 	  || current_function_decl))
@@ -7898,7 +7898,7 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
 
   if (warn_about_return_type)
     pedwarn_c99 (loc, flag_isoc99 ? 0
-		 : (warn_return_type ? OPT_Wreturn_type : OPT_Wimplicit_int),
+		 : (GCC_OPTION (warn_return_type) ? OPT_Wreturn_type : OPT_Wimplicit_int),
 		 "return type defaults to %<int%>");
 
   /* Make the init_value nonzero so pushdecl knows this is not tentative.
@@ -7964,14 +7964,14 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
     }
 
   /* Optionally warn of old-fashioned def with no previous prototype.  */
-  if (warn_strict_prototypes
+  if (GCC_OPTION (warn_strict_prototypes)
       && old_decl != error_mark_node
       && !prototype_p (TREE_TYPE (decl1))
       && C_DECL_ISNT_PROTOTYPE (old_decl))
     warning_at (loc, OPT_Wstrict_prototypes,
 		"function declaration isn%'t a prototype");
   /* Optionally warn of any global def with no previous prototype.  */
-  else if (warn_missing_prototypes
+  else if (GCC_OPTION (warn_missing_prototypes)
 	   && old_decl != error_mark_node
 	   && TREE_PUBLIC (decl1)
 	   && !MAIN_NAME_P (DECL_NAME (decl1))
@@ -7981,7 +7981,7 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
 		"no previous prototype for %qD", decl1);
   /* Optionally warn of any def with no previous prototype
      if the function has already been used.  */
-  else if (warn_missing_prototypes
+  else if (GCC_OPTION (warn_missing_prototypes)
 	   && old_decl != 0
 	   && old_decl != error_mark_node
 	   && TREE_USED (old_decl)
@@ -7989,7 +7989,7 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
     warning_at (loc, OPT_Wmissing_prototypes,
 		"%qD was used with no prototype before its definition", decl1);
   /* Optionally warn of any global def with no previous declaration.  */
-  else if (warn_missing_declarations
+  else if (GCC_OPTION (warn_missing_declarations)
 	   && TREE_PUBLIC (decl1)
 	   && old_decl == 0
 	   && !MAIN_NAME_P (DECL_NAME (decl1)))
@@ -7998,7 +7998,7 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
 		decl1);
   /* Optionally warn of any def with no previous declaration
      if the function has already been used.  */
-  else if (warn_missing_declarations
+  else if (GCC_OPTION (warn_missing_declarations)
 	   && old_decl != 0
 	   && old_decl != error_mark_node
 	   && TREE_USED (old_decl)
@@ -8019,7 +8019,7 @@ start_function (struct c_declspecs *declspecs, struct c_declarator *declarator,
     maybe_apply_pragma_weak (decl1);
 
   /* Warn for unlikely, improbable, or stupid declarations of `main'.  */
-  if (warn_main && MAIN_NAME_P (DECL_NAME (decl1)))
+  if (GCC_OPTION (warn_main) && MAIN_NAME_P (DECL_NAME (decl1)))
     {
       if (TYPE_MAIN_VARIANT (TREE_TYPE (TREE_TYPE (decl1)))
 	  != integer_type_node)
@@ -8454,7 +8454,7 @@ store_parm_decls (void)
   /* Initialize the RTL code for the function.  */
   allocate_struct_function (fndecl, false);
 
-  if (warn_unused_local_typedefs)
+  if (GCC_OPTION (warn_unused_local_typedefs))
     cfun->language = ggc_alloc_cleared_language_function ();
 
   /* Begin the statement tree for this function.  */
@@ -8569,7 +8569,7 @@ finish_function (void)
   finish_fname_decls ();
 
   /* Complain if there's just no return statement.  */
-  if (warn_return_type
+  if (GCC_OPTION (warn_return_type)
       && TREE_CODE (TREE_TYPE (TREE_TYPE (fndecl))) != VOID_TYPE
       && !current_function_returns_value && !current_function_returns_null
       /* Don't complain if we are no-return.  */
@@ -8590,7 +8590,7 @@ finish_function (void)
     }
 
   /* Complain about parameters that are only set, but never otherwise used.  */
-  if (warn_unused_but_set_parameter)
+  if (GCC_OPTION (warn_unused_but_set_parameter))
     {
       tree decl;
 
@@ -8808,7 +8808,7 @@ c_pop_function_context (void)
   /* When -Wunused-local-typedefs is in effect, cfun->languages is
      used to store data throughout the life time of the current cfun,
      So don't deallocate it.  */
-  if (!warn_unused_local_typedefs)
+  if (!GCC_OPTION (warn_unused_local_typedefs))
     cfun->language = NULL;
 
   if (DECL_STRUCT_FUNCTION (current_function_decl) == 0
@@ -9774,7 +9774,7 @@ declspecs_add_type (location_t loc, struct c_declspecs *specs,
 
 	  /* If this typedef name is defined in a struct, then a C++
 	     lookup would return a different value.  */
-	  if (warn_cxx_compat
+	  if (GCC_OPTION (warn_cxx_compat)
 	      && I_SYMBOL_BINDING (DECL_NAME (type))->in_struct)
 	    warning_at (loc, OPT_Wc___compat,
 			"C++ lookup of %qD would return a field, not a type",
@@ -9782,7 +9782,7 @@ declspecs_add_type (location_t loc, struct c_declspecs *specs,
 
 	  /* If we are parsing a struct, record that a struct field
 	     used a typedef.  */
-	  if (warn_cxx_compat && struct_parse_info != NULL)
+	  if (GCC_OPTION (warn_cxx_compat) && struct_parse_info != NULL)
 	    struct_parse_info->typedefs_seen.safe_push (type);
 	}
     }
@@ -10364,11 +10364,11 @@ c_write_global_declarations (void)
   gcc_assert (!current_scope);
 
   /* Handle -fdump-ada-spec[-slim]. */
-  if (flag_dump_ada_spec || flag_dump_ada_spec_slim)
+  if (GCC_OPTION (flag_dump_ada_spec) || GCC_OPTION (flag_dump_ada_spec_slim))
     {
       /* Build a table of files to generate specs for */
-      if (flag_dump_ada_spec_slim)
-	collect_source_ref (main_input_filename);
+      if (GCC_OPTION (flag_dump_ada_spec_slim))
+	collect_source_ref (GCC_OPTION (main_input_filename));
       else
 	for_each_global_decl (collect_source_ref_cb);
 
@@ -10428,7 +10428,7 @@ c_register_addr_space (const char *word, addr_space_t as)
 
   /* Address space qualifiers are only supported
      in C with GNU extensions enabled.  */
-  if (c_dialect_objc () || flag_no_asm)
+  if (c_dialect_objc () || GCC_OPTION (flag_no_asm))
     return;
 
   id = get_identifier (word);
